%cross validation for libsvm to choose Gaussian hyper-parameter
function [optgs, optC,cvaccu] = libsvm_cv(X, Y, C, gs, fold)
%cross-validation over C and gs  for Gaussian
cvaccu = zeros(length(gs),length(C));
ns = length(Y);
fprintf('--- %d-fold cross validation for LIBSVM ---\n',fold);
for frep = 1:fold

    fprintf('--- data split: %d \n',frep);

    ind = randperm(ns);
    ty = Y(ind);
    tx = X(ind,:);
    nte = floor(ns/fold);
    ntr = ns - nte;
    %spliting the dataset
    ytr = ty(1 : ntr);
    yte = ty(ntr+1 : end);
    weight= 1;             %weight the SVM C penalties 
    for i = 1:length(gs)
        %creating kernels
        k_type = 'gauss';
        k_par = gs(i);
        K = create_kernel(tx,tx,k_type,k_par);
        for j = 1:length(C)
            c = C(j);
            libsvmparam= ['-s 0 -c ',num2str(c),' -t 4 -e .0001 -w1 1 -w-1 ',num2str(weight)]; % used to compute dual value
            svmmodel = svmtrain(ytr,[(1:length(ytr))',K(1:ntr,1:ntr)],libsvmparam);
            alpha_temp=zeros(length(ytr),1);alpha_temp(svmmodel.SVs)=abs(svmmodel.sv_coef);
            b=estimate_b(alpha_temp, K(1:ntr,1:ntr), ytr, c); % estimate b parameter
            pred=sign(K(ntr+1:end,1:ntr)*(alpha_temp.*ytr)+b); % make the predictions
            cvaccu(i,j) =  cvaccu(i,j)+ sum(pred==yte)./length(yte);
        end
    end
end
[a, opti] = max(max(cvaccu,[],2));
optgs = gs(opti);
[b, optj] = max(cvaccu(opti,:));
optC = C(optj);
